/* 
 * Copyright (c) 1995 The University of Utah and
 * the Computer Systems Laboratory at the University of Utah (CSL).
 * All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software is hereby
 * granted provided that (1) source code retains these copyright, permission,
 * and disclaimer notices, and (2) redistributions including binaries
 * reproduce the notices in supporting documentation, and (3) all advertising
 * materials mentioning features or use of this software display the following
 * acknowledgement: ``This product includes software developed by the
 * Computer Systems Laboratory at the University of Utah.''
 *
 * THE UNIVERSITY OF UTAH AND CSL ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS
 * IS" CONDITION.  THE UNIVERSITY OF UTAH AND CSL DISCLAIM ANY LIABILITY OF
 * ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * CSL requests users of this software to return to csl-dist@cs.utah.edu any
 * improvements that they make and grant CSL redistribution rights.
 *
 *      Author: Bryan Ford, University of Utah CSL
 */

/*
 * Note that there's no longer a cninit() call:
 * the "console" is considered always available
 * and doesn't need to be initialized explicitly.
 */

/* Once a console character is translated appropriately,
   this sends it to each of the active consoles.  */
void
cnputc(unsigned char c)
{
#define console(name) name##_cnputc(c);
#include "console_list.h"
#undef console
}

int
cnmaygetc()
{
	int c;
#define console(name) if ((c = name##_cnmaygetc()) >= 0) return c;
#include "console_list.h"
#undef console
	return -1;
}

cngetc()
{
	int c;
	while ((c = cnmaygetc()) < 0);
	return c;
}

